--[[----------------------------------------------------------------------------

WFSQLiteDatabaseUtilsWorker.lua

--------------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2017 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remain the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and may be covered by U.S. and Foreign
Patents, patents in process, and are protected by trade secret or copyright
law.  Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

------------------------------------------------------------------------------]]

	-- WF.core.lua.threading
local WFRequestDispatcher = require 'WFRequestDispatcher'

	-- WF.sqlite.database
local WFSQLiteDatabase = require 'WFSQLiteDatabase'
local WFSQLiteDatabaseSchema = require 'WFSQLiteDatabaseSchema'

--------------------------------------------------------------------------------

local function createInMemoryDbFromPath( path, schemaVersion )

	local schema = WFSQLiteDatabaseSchema( schemaVersion)

	local dbFromPath = WFSQLiteDatabase( path, schema )

	local memoryDb = dbFromPath:onlineBackup( 
						WFSQLiteDatabase( ':memory:', schema ) )

	dbFromPath:close()

	return memoryDb:createTransitableRefAndClose()

end

--------------------------------------------------------------------------------

local function initMessageProcessor()

	WFRequestDispatcher.onMessage( 'createInMemoryDbFromPath',
										createInMemoryDbFromPath )

end

--==============================================================================

return {

	initMessageProcessor = initMessageProcessor

}
